/**
 * This callback is called when the SocketEventListener 'recieveQueryData'
 * has been triggered. It takes the incoming chunk and renders the results in a
 * the results.jsList. It can eiterh hande llive incoming data or imported
 * results data.
 */
function queryRenderResults(payload, client, imported=false) {
  console.info("Current recieved chunk:", payload.chunk);
  if (payload.chunk.cpos_ranges == true) {
    client.results.data["cpos_ranges"] = true;
  } else {
    client.results.data["cpos_ranges"] = false;
  }
  /**
   * resultItem is a list where
   */
  let resultItems = [];
  // get infos for full match row
  for (let [index, match] of payload.chunk.matches.entries()) {
    resultItems.push({...match, ...{"index": index + client.results.data.matches.length}});
  }
  if (!imported) {
    // update progress bar
    // queryResultsDeterminateElement.style.width = `${payload.progress}%`;
    client.results.jsList.add(resultItems, (items) => {
      for (let item of items) {
        item.elm = client.results.jsList.createResultRowElement(item, payload.chunk);
      }
    });
    helperQueryRenderResults(payload, client);
    // if (progress === 100) {
    //   resultsCreateElement.classList.remove("disabled");
    //   queryResultsProgressElement.classList.add("hide");
    //   queryResultsUserFeedbackElement.classList.add("hide");
    //   resultsExportElement.classList.remove("disabled");
    //   addToSubResultsElement.removeAttribute("disabled");
    //   // inital expert mode check and sub results activation
    //   client.results.jsList.activateInspect();
    //   if (addToSubResultsElement.checked) {
    //     client.results.jsList.activateAddToSubResults();
    //   }
    //   if (expertModeSwitchElement.checked) {
    //     client.results.jsList.expertModeOn("query-display");
    //   }
    // }
  } else if (imported) {
    client.results.jsList.add(resultItems, (items) => {
      for (let item of items) {
        item.elm = client.results.jsList.createResultRowElement(item, payload.chunk,
                                                         true);
      }
      helperQueryRenderResults(payload, client);
      progress = 100;
      client.results.jsList.activateInspect();
      if (expertModeSwitchElement.checked) {
        client.results.jsList.expertModeOn("query-display");
      }
    });
  }
}

function helperQueryRenderResults (payload, client) {
  // updating table on finished item creation callback via createResultRowElement
  client.results.jsList.update();
  client.results.jsList.changeContext(); // sets lr context on first result load
  // incorporating new chunk results into full results
  client.results.data.matches.push(...payload.chunk.matches);
  client.results.data.addData(payload.chunk.cpos_lookup, "cpos_lookup");
  client.results.data.addData(payload.chunk.text_lookup, "text_lookup");
  // complete metaData
  // client.results.metaData.add();
  // show user current and total match count
  // receivedMatchCountElement.innerText = `${client.results.data.matches.length}`;
  // textLookupCountElement.innerText = `${Object.keys(client.results.data.text_lookup).length}`;
  let titles = new Array();
  for (let [key, value] of Object.entries(client.results.data.text_lookup)) {
    titles.push(`${value.title} (${value.publishing_year})`);
  };
  // textTitlesElement.innerText = `${titles.join(", ")}`;
  // upate progress status
  // progress = payload.progress;  // global declaration
}

export { queryRenderResults }